Name:           libsx
Summary:        Simple X library
Version:        2.05
Release:        5%{?dist}
Group:          System Environment/Libraries
License:        LGPL
Url:            ftp://ftp.ac-grenoble.fr/ge/Xlibraries/
Source:	        ftp://ftp.ac-grenoble.fr/ge/Xlibraries/%{name}-%{version}.tar.bz2
Patch:          libsx-no_nested_prototypes.diff
Patch1:         libsx-comment_caddr_t.diff
Patch2:         libsx-protect_strdup.diff
Patch3:         libsx-freq_simple.diff
Patch4:         libsx-mkdir_p.diff
Patch5:         libsx-shared.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  xorg-x11-devel

%description
Libsx (the Simple X library) is a library of code that sits on top of and 
to the side of the Athena widget set.  Its purpose is to make writing X 
applications *much* easier.  

%package devel
Summary:       Headers and development libraries for libsx
Group:         Development/Libraries
Requires:      %{name} = %{version}-%{release}
Requires:      xorg-x11-devel

%description devel
Libsx (the Simple X library) is a library of code that sits on top of and
to the side of the Athena widget set.

The libsx-devel package contains headers and development libraries
necessary for building programs against libsx.


%prep
%setup -q
%patch -p1
# caddr_t redefined?
%patch -P 1
# with RPM_OPT_FLAGS (maybe FORTIFY_SOURCE) all the strdup prototypes
# have to be commented.
%patch -p1 -P 2
# use the new GetFile in freq
%patch -p1 -P 3
# use mkdir -p to create directories
%patch -p1 -P 4
# shared library with fine soname
%patch -p0 -P 5

%build
%ifarch x86_64
	mv libsx_defs libsx_defs-old
#	sed -e s/'CFLAGS = -Wall -O2 -D_POSIX_SOURCE'/'CFLAGS = -Wall -O2 -D_POSIX_SOURCE -fPIC'/g \
	sed -e s/'\/usr\/X11R6\/lib'/'\/usr\/X11R6\/lib64'/g \
	libsx_defs-old >libsx_defs
%endif
mv libsx_defs libsx_defs-old
sed -e s/'CFLAGS = -Wall -O2 -D_POSIX_SOURCE'/"CFLAGS = %{optflags} -fPIC"/g \
	libsx_defs-old >libsx_defs
make src

%install
rm -rf %{buildroot}

# remove symlinks pointing to libsx.h in example directories
find . -name libsx.h -a -type l -exec rm \{\} \;

cd src
%makeinstall LIBDIR=%{buildroot}%{_libdir} \
		INCLUDEDIR=%{buildroot}%{_includedir} \
		SHAREDIR=%{buildroot}%{_datadir}/libsx

# fix symbolic links for shared library
cd $RPM_BUILD_ROOT/%{_libdir}
mv libsx.so libsx.so.0.0.0
chmod +x libsx.so.0.0.0
ln -s libsx.so.0.0.0 libsx.so.0
ln -s libsx.so.0.0 libsx.so

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc CHANGES HELP HINTS LICENSE README 
%{_libdir}/libsx.so.*
%{_datadir}/libsx

%files devel
%doc bezier controlbox creq demo* docs draw_demo frac freq multireq
%doc pcurve skel xmore xrootbg libsx_defs
%{_libdir}/libsx.a
%{_libdir}/libsx.so
%{_includedir}/libsx.h

%changelog
* Fri Aug 26 2005 Patrice Dumas <dumas@centre-cired.fr> 2.05-5
- replace mkinstalldirs with mkdir -p

* Fri Aug 26 2005 Patrice Dumas <dumas@centre-cired.fr> 2.05-4
- correct Requires
- remove links to the libsx.h header files in the example directories

* Tue Aug 16 2005 Patrice Dumas <dumas@centre-cired.fr> 2.05-3
- don't ship freq.h or libfreq.a, it is an example
- add a simpler definition of SimpleGetFile in freq
- ship the example dirs and the doc
- use and ship mkinstalldirs to create the dirs instead of mkdirhier
- handle correctly shared libraries

* Fri Aug 12 2005 Patrice Dumas <dumas@centre-cired.fr> 2.05-2
- use %{optflags} and build on fedora with gcc4
- reused spec from http://monkeyrpms.net/fc2-i386/html/libsx.html
